CREATE OR REPLACE
PROCEDURE USR_EXPO_ITEMAUTF_SAP(P_ALTINCSAP     IN VARCHAR2 DEFAULT 'INC',
                                P_IDENTIFIC     IN NUMBER DEFAULT 0,
                                P_IDINTERFACEAF IN NUMBER DEFAULT 0)
IS
   V_CCOMMIT        INTEGER;
   V_ALTERACAO      VARCHAR2(01);
   V_SERVICO        VARCHAR2(01);
   V_STATUS         INTEGER;
   V_CODIGO_GRUPO   VARCHAR2(20);
   V_GRUPO_PRODUTO  VARCHAR2(50);
   V_DTUTILIZA      VARCHAR2(10);
   V_ALTINCSAP      VARCHAR2(03);
   V_TPINTERFACE    VARCHAR2(01);
   V_NUMEROITEM     NUMBER(4);
   V_IDFUNCAOFILI   VARCHAR2(01);
   V_NMPRODUTO      PRODUTO.NMPRODUTO%TYPE;
   V_CDARVPROD      PRODUTO.CDARVPROD%TYPE;
   V_SGUNIDADE      PRODUTO.SGUNIDADE%TYPE;
   V_NMMARCA        MARCA.NMMARCA%TYPE;
   V_CDPRODESTO     PRODUTO.CDPRODESTO%TYPE;
   V_IDENTIFIC      VARCHAR2(10);
BEGIN
   V_CCOMMIT   := 0;
   /* Fixo T */
   V_ALTERACAO := 'T';
   /* Servio = S
      Fixo = N */
   V_SERVICO := 'N';
   /* 0 - OK
      1 - Novo
      2 - Erro
      3 - Em Processo */
   V_STATUS := 1;

   V_ALTINCSAP := P_ALTINCSAP;
   V_IDENTIFIC := TO_CHAR(P_IDENTIFIC);
   V_IDENTIFIC := LPAD(V_IDENTIFIC, 10, '0');
   FOR C_ITEMAUTF IN (SELECT I.CDFILDEST, I.CDFILLANC, I.NRAUTOFORN, I.CDPRODUTO,
                             P.CDARVPROD,
                             P.NMPRODUTO,
                             P.SGUNIDADE,
                             I.DTPROGENTAF, I.QTPROGENTAF,
                             I.QTEFETENTRAF, I.VRPREUNIAF, I.IDBAIXITMAF, I.IDBAIXITAFS, I.QTATENDPEDOL,
                             CASE CASE NVL(A.IDBAIXAAF, '0') WHEN '4' THEN 'S'
                                                             WHEN '5' THEN 'S'
                                                             ELSE 'N' END WHEN 'S' THEN 'S'
                                  ELSE 'N'
                             END CANCELADO, I.CDMARCA,
                             I.TXOBSITMAF, NVL(I.USR_TPINTERFACE_SAP,'I') USR_TPINTERFACE_SAP,
                             I.DTENTRITMSOL, P.CDPRODESTO,
                             ROWNUM NUMEROITEM
                        FROM AUTOFORNE A INNER JOIN ITEMAUTF I ON I.CDFILDEST  = A.CDFILDEST
                                                              AND I.CDFILLANC  = A.CDFILLANC
                                                              AND I.NRAUTOFORN = A.NRAUTOFORN
                                         INNER JOIN PRODUTO P ON P.CDPRODUTO = I.CDPRODUTO
                       WHERE A.NRAUTOFORN         = V_IDENTIFIC

                       UNION ALL

                      SELECT CENTRO CDFILDEST, ' ' CDFILLANC, IDENTIFIC, I.CDPRODARVORIG CDPRODUTO,
                             P.CDARVPROD,
                             P.NMPRODUTO,
                             P.SGUNIDADE,
                             I.DTPROGENTAF, 0 QTPROGENTAF,
                             I.QTEFETENTRAF, PRECO VRPREUNIAF, I.IDBAIXITMAF, I.IDBAIXITAFS, I.QTATENDPEDOL,
                             'S' CANCELADO, CDFABRICANTE CDMARCA,
                             COMPLEMENTO TXOBSITMAF, 'E' USR_TPINTERFACE_SAP,
                             TO_DATE(I.EXTRA, 'DD/MM/YYYY') DTENTRITMSOL, P.CDPRODESTO,
                             NUMEROITEM
                        FROM USR_SAP_ITEMAUTF I INNER JOIN PRODUTO P ON P.CDARVPROD = I.CDPRODUTO
                        WHERE IDENTIFIC = P_IDENTIFIC
                          AND NOT EXISTS(SELECT 1
                                           FROM  ITEMAUTF, MARCA
                                           WHERE ITEMAUTF.CDFILDEST  = I.CENTRO
                                             AND ITEMAUTF.NRAUTOFORN = V_IDENTIFIC
                                             AND ITEMAUTF.CDMARCA    = MARCA.CDMARCA
                                             --AND ITEMAUTF.DTPROGENTAF= I.DTPROGENTAF
                                             AND MARCA.NMMARCA       = I.FABRICANTE
                                             AND ITEMAUTF.CDPRODUTO   =  I.CDPRODARVORIG)
                          AND NOT EXISTS(SELECT 1
                                           FROM USR_SAP_ITEMAUTF
                                          WHERE USR_SAP_ITEMAUTF.CENTRO    = I.CENTRO
                                            AND USR_SAP_ITEMAUTF.IDENTIFIC = I.IDENTIFIC
                                            AND USR_SAP_ITEMAUTF.CANCELADO = 'S'
                                            AND USR_SAP_ITEMAUTF.CDPRODUTO = I.CDPRODUTO
                                            AND USR_SAP_ITEMAUTF.FABRICANTE = I.FABRICANTE
                                            --AND USR_SAP_ITEMAUTF.DTPROGENTAF = I.DTPROGENTAF
                                            )
                        ) LOOP

      BEGIN
         SELECT NVL(MAX(IDFUNCAOFILI), 'A')
           INTO V_IDFUNCAOFILI
           FROM FILIAL
          WHERE CDFILIAL = C_ITEMAUTF.CDFILDEST;

         SELECT NVL(MAX(NMMARCA), C_ITEMAUTF.CDMARCA)
           INTO V_NMMARCA
           FROM MARCA
          WHERE CDMARCA = C_ITEMAUTF.CDMARCA;

         V_NUMEROITEM    := C_ITEMAUTF.NUMEROITEM;
         V_NMPRODUTO     := C_ITEMAUTF.NMPRODUTO;
         V_CDARVPROD     := C_ITEMAUTF.CDARVPROD;
         V_SGUNIDADE     := C_ITEMAUTF.SGUNIDADE;

         IF V_IDFUNCAOFILI = 'O' THEN
            SELECT MAX(NMPRODUTO), MAX(CDARVPROD), MAX(SGUNIDADE)
              INTO V_NMPRODUTO, V_CDARVPROD, V_SGUNIDADE
              FROM RELACPRODOL, PRODUTO
             WHERE RELACPRODOL.CDPRARVORIG = PRODUTO.CDPRODUTO
               AND RELACPRODOL.CDPRODARVOL = C_ITEMAUTF.CDPRODUTO;
         END IF;
         SELECT TO_CHAR(MIN(I.DTUTILIZA),'DD/MM/YYYY')
           INTO V_DTUTILIZA
           FROM AUTOFORNE A INNER JOIN ITEMSOLI  I  ON A.CDFILDEST = I.CDFILSOLI
                            INNER JOIN PRODUTO   P  ON P.CDPRODUTO = I.CDPRODUTO
                            INNER JOIN APURPRECO AP ON ((AP.CDFILCENTCMP = A.CDFILLANC) OR (AP.CDFILLANC = A.CDFILLANC))
                                                    AND AP.NRAPURPREC = A.NRSEQAPURAF
          WHERE A.CDFILDEST  = C_ITEMAUTF.CDFILDEST
            AND A.CDFILLANC  = C_ITEMAUTF.CDFILLANC
            AND A.NRAUTOFORN = C_ITEMAUTF.NRAUTOFORN
            AND P.CDPRODESTO = C_ITEMAUTF.CDPRODESTO
            AND NVL(I.IDITMCONS, 'N')  = 'N'
            AND NVL(I.IDSOLIAPROV, 'S') = 'S'
            AND I.CDFILIOPELOG IS NULL
            AND ((I.IDITMSOLEXTRA = AP.IDCONSOLAPUEFET) OR (AP.IDCONSOLAPUEFET = 'X'))
            AND I.DTPROGENTR = C_ITEMAUTF.DTENTRITMSOL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_DTUTILIZA := NULL;
      END;

      SELECT MAX(CDARVPROD), MAX(NMPRODUTO)
        INTO V_CODIGO_GRUPO, V_GRUPO_PRODUTO
        FROM PRODUTO
       WHERE CDNVPRODUTO = 3
         AND CDARVPROD IN SUBSTR((SELECT CDARVPROD
                                    FROM PRODUTO
                                   WHERE CDPRODUTO = C_ITEMAUTF.CDPRODUTO), 1, LENGTH(CDARVPROD));

         SELECT NVL(MAX('A'), 'I')
           INTO V_TPINTERFACE
           FROM USR_SAP_ITEMAUTF
          WHERE IDENTIFIC     = TO_NUMBER(C_ITEMAUTF.NRAUTOFORN)
            AND CDPRODARVORIG = C_ITEMAUTF.CDPRODUTO;

         SELECT MAX(NUMEROITEM)
           INTO V_NUMEROITEM
           FROM USR_SAP_ITEMAUTF
          WHERE IDENTIFIC     = TO_NUMBER(C_ITEMAUTF.NRAUTOFORN)
            AND CDPRODARVORIG = C_ITEMAUTF.CDPRODUTO;

         IF V_NUMEROITEM IS NULL THEN
            SELECT NVL(MAX(NUMEROITEM),0)+1
              INTO V_NUMEROITEM
              FROM USR_SAP_ITEMAUTF
             WHERE IDENTIFIC = TO_NUMBER(C_ITEMAUTF.NRAUTOFORN);
         END IF;

         INSERT INTO USR_SAP_ITEMAUTF(ALTERACAO, NUMEROITEM, CDPRODUTO, CENTRO, IDENTIFIC,
                                      DESCRICAO, COMPLEMENTO, UNIDADE, CODIGO_GRUPO, GRUPO_PRODUTO,
                                      FABRICANTE, DTPROGENTAF, QUANTIDADE, QTEFETENTRAF, PRECO,
                                      IDBAIXITMAF, IDBAIXITAFS, QTATENDPEDOL, CANCELADO, GENERICO,
                                      EXTRA, SERVICO, IDINTERFACE, TPINTERFACE, DTINTERFACEORI,
                                      DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO, IDINTERFACEAF,
                                      CDPRODARVORIG, CDFABRICANTE)
              VALUES (V_ALTERACAO, V_NUMEROITEM, V_CDARVPROD, C_ITEMAUTF.CDFILDEST, C_ITEMAUTF.NRAUTOFORN,
                      V_NMPRODUTO, C_ITEMAUTF.TXOBSITMAF, V_SGUNIDADE, V_CODIGO_GRUPO, V_GRUPO_PRODUTO,
                      V_NMMARCA, C_ITEMAUTF.DTPROGENTAF, C_ITEMAUTF.QTPROGENTAF, C_ITEMAUTF.QTEFETENTRAF, C_ITEMAUTF.VRPREUNIAF,
                      C_ITEMAUTF.IDBAIXITMAF, C_ITEMAUTF.IDBAIXITAFS, C_ITEMAUTF.QTATENDPEDOL, C_ITEMAUTF.CANCELADO, 'N',
                      V_DTUTILIZA, V_SERVICO, USR_SAP_ITMAF_IDINTERFACE.NEXTVAL, V_TPINTERFACE, SYSDATE,
                      NULL, V_STATUS, 1, 4, P_IDINTERFACEAF, C_ITEMAUTF.CDPRODUTO, C_ITEMAUTF.CDMARCA);

      UPDATE ITEMAUTF
         SET USR_IDINTEGRAMESAP  = 'N',
             USR_TPINTERFACE_SAP = C_ITEMAUTF.USR_TPINTERFACE_SAP
       WHERE CDFILDEST   = C_ITEMAUTF.CDFILDEST
         AND CDFILLANC   = C_ITEMAUTF.CDFILLANC
         AND NRAUTOFORN  = C_ITEMAUTF.NRAUTOFORN
         AND CDMARCA     = C_ITEMAUTF.CDMARCA
         AND CDPRODUTO   = C_ITEMAUTF.CDPRODUTO
         AND DTPROGENTAF = C_ITEMAUTF.DTPROGENTAF;

      V_CCOMMIT := V_CCOMMIT + 1;
      /*IF V_CCOMMIT > 200 THEN
         COMMIT;
      END IF;*/
   END LOOP;
   --COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_EXPO_ITEMAUTF_SAP','6.02.xxx'); END;
/